*** PGcollect 1.6 Rainer M. Kreten, NLPHH , 2021, 2022**************************************
*** Abgleich zwischen lokalen SQlite und GPKG-Datenbanken und Postgis
*** Daten aus GPKG auslesen ***
*** kompiliert mit BUILD 
***
*** Die Datei hbmk.hbm muss im Verzeichnis liegen !!!!!!!!
***
*** alle Tabellen in kleinbuchstaben anlegen!
#include "hfcl.ch"
#include "minigui.ch"
#include "hmg.ch"
#include "postgres.ch"
Function Main
public merfolg := .T.
public mcrlf := chr(13) + chr(10)
public conn := NIL
public res := NIL
public msatzanzahl := 0
public mgeradedran := 0
public mupdatenr := 0
public minsertnr := 0

set century on
set date german
set language to german
set codepage to german
clear
    DEFINE WINDOW Win_1 ;
        AT 100,100 ;
        WIDTH 660 ;
        HEIGHT 350 ;
        TITLE 'PGcollect 1.6 November 2022, Datenabgleich zum Server' ;
        MAIN;
		TOPMOST;
		on init  fhauptschleife()

 // Label           
 @ 20,20 LABEL Label_1 VALUE 'Tabelle' WIDTH 100 HEIGHT 30 FONT 'Arial' SIZE 16 BOLD
 @ 70,20 Label Label_2 Value 'Datenstze' width 500 Height 30 Font 'Arial' Size 16
 
 @ 120,20 Label Label_3 Value 'Neu' width 300 Height 30 Font 'Arial' Size 16 
 @ 170,20 Label Label_4 Value 'Updates' width 300 Height 30 Font 'Arial' Size 16
 // Anzeigewerte
 @ 20,170 Label Label_11 value ' ' width 450 height 30 Font 'Arial' Size 16 BOLD 
 @ 70,170 Label Label_12 value ' '   width 450 height 30 Font 'Arial' Size 16  
 @ 120,170 Label Label_13 value ' '  width 450 height 30 Font 'Arial' Size 16  
 @ 170,170 Label Label_14 value ' '  width 450 height 30 Font 'Arial' Size 16  
 
 @ 220,20 PROGRESSBAR Progress_1 RANGE 1,100 Width 600 Height 15
 @ 270,300 Label Label_15 value '---' width 150 height 30 autosize Font 'Arial' size 16 centeralign
 
END WINDOW
   ACTIVATE WINDOW Win_1
 
fhauptschleife()
 quit
 *** Ende des Hauptprogrammes *************************************************
function fhauptschleife()
strfile("Datenabgleich vom " + dtoc(date()) + " " + left(time(),5) + " Rechner: " + getcomputername() + " Benutzer: " + getusername(), "PGcollect.log")
fpruef("pgcollect.dbf") // Konfigurationsdatei im Exclusivzugriff?
use pgcollect
go top
do while .not. eof()
   if left(alltrim(COMMENT),1) <> '#'
      fpruef(ldatei) // lokale DB im Exklusivzugriff?
	   if lower(alltrim(ZURUECK)) = 'bi' .or. lower(alltrim(ZURUECK)) = 'up'
          fsqlitedump()  // exportieren der SQLITE-DB nach CSV, CSVT mit ogr2ogr
	      // Anzahl Datenstze ermitteln und ausgeben
          msqlite2pg = filestr("$sqlite2pg.csv")
          msatzanzahl = numtoken(msqlite2pg,chr(10))
          win_1.label_12.value := alltrim(str(msatzanzahl -1,8,0))
          release msqlite2pg    
          fbuildscript() // Einlesen der CSV und Generieren von SQL-Befehlen an die PG-DB
          strfile(mcrlf + "***** Ende mit Tabelle " + alltrim(ltabelle) + ' *****' + replicate(mcrlf,2),"PGcollect.log",.T.)
          pqreset(conn)
	   endif	 
	  if lower(alltrim(ZURUECK)) = 'bi' .or. lower(alltrim(ZURUECK)) = 'down' 
         fpgexport() // exportieren der PG
      endif
	endif  
   skip
enddo
strfile(mcrlf + '<<< Ende >>> ' + mcrlf,"PGcollect.log",.T.)
use
 set print off
 set print to
msginfo('Datenabgleich beendet.','Fertigmeldung') 
quit
*******************************************************************************
function fsqlitedump()
// set console on
set console off
fpgconnect()
win_1.Label_11.value := alltrim(ltabelle)  // Anzeige Tabellenname 
set print to $sqlite2pg.bat
set print on
?
? "Echo off"
? "REM $SQLITE2PG.BAT , Entladen der SQLITE-DB per ogr2ogr"
? "DEL $sqlite2PG.csv"
? "DEL $sqlite2PG.csvt"
?
? 'ogr2ogr -f "csv" $sqlite2pg.csv ' + alltrim(ldatei) + ' -sql "select  * from ' + chr(39) + alltrim(ltabelle) + chr(39) + ' " -skipfailures -lco SEPARATOR=SEMICOLON -lco GEOMETRY=AS_WKT -lco CREATE_CSVT=YES'
? 
?
set print off
set print to
strfile(mcrlf + "***** Exportieren der Tabelle " + alltrim(ltabelle) + " *****" + mcrlf,"PGcollect.log",.T.)
fileappend("$sqlite2pg.bat","PGcollect.log")
execute file "$sqlite2pg.bat" wait
if .not. file("$sqlite2pg.csv")
   fende("Fehler beim Starten von  ogr2ogr, stimmt der Pfad?")
endif
return
*******************************************************************************
Function fbuildscript()
mupdatenr := 0
minsertnr := 0
 set print to $sqlite2pg.sql.txt
 set print on
mconfig = filestr("$sqlite2pg.csvt")
mfhnr = fopen("$sqlite2pg.csv",0)  && Filehandle ermitteln
fseek(mfhnr,0,0)  && Pointer auf Dateianfang
mfsatz := space(20000)  && leere Variable anlegen
mlfdnr := 0
mgelesen := 0
mreadbytes := 0
midentifier := "ungueltig"
midentpos := 1
mzeitpos := 1
mupdatesql := ""
minsertsql := ""
mwhereobj := ""
mwherezeit := ""
mgeradedran := 1
strfile('Die CSV-Datei wird in Postgres importiert...' + mcrlf + mcrlf ,"PGcollect.log",.T.)
do while mreadbytes = 0   // zeilenweise einlesen
   mreadbytes = HB_freadline(mfhnr,@mfsatz,chr(13) + chr(10))
   mfsatz = " " + ATrepl(";",mfsatz,"; ")
   mfsatz = charrem(chr(34),mfsatz)
   if len(mfsatz) < 10 // restliche Leerstze
      exit
   endif  
   
   if mgelesen = 0 // die Kopfzeile
      mkopfzeile = mfsatz
	  mfeldanzahl = numtoken(mkopfzeile,";")// Anzahl der ; zhlen
	  // ermitteln des Identifikationsfeldes, z.B. uuid
	  midentpos = 1
	  do while midentpos < mfeldanzahl + 1
	     if upper(alltrim(token(mkopfzeile,";",midentpos))) = upper(alltrim(identifier))
            midentifier = alltrim(token(mkopfzeile,";",midentpos))
			exit // Position gefunden, Schleifenaussprung
		 else
         midentpos ++
		 endif
      enddo
      // ermitteln des Feldes fr Zeitstempel
	  mzeitpos = 1
	  do while mzeitpos <mfeldanzahl + 1
	     if upper(alltrim(token(mkopfzeile,";",mzeitpos))) = upper(alltrim(lzeit))
		 exit // Position gefunden, Schleifenaussprung
		 else
         mzeitpos ++
		 endif
      enddo
	  // Ende Kopfzeile
   else
   *** Fuer jedes Objekt wird zunchst ermittelt, ob es vorhanden ist, wenn nicht wird ein Leersatz angehngt, der nur die ID und timestamp 0 enthlt.
           mgeradedran ++
   	       mabfrage = pqexec(conn,'select * from ' + alltrim(schema) + '.' + alltrim(stabelle) + ' where ' + lower(alltrim(identifier)) + ' = ' + chr(39) + alltrim(token(mfsatz,";",midentpos)) + chr(39) +   + ' ;')
		   maresultat := PQRESULT2ARRAY(mabfrage)
		   if len(maresultat) = 0 // nicht vorhanden, also Insert
		      minsertnr ++
			  mupdatenr --
		      minsertsql = 'INSERT INTO ' + alltrim(schema) + '.' + alltrim(stabelle) + ' (' + lower(alltrim(identifier)) +' , ' + lower(alltrim(lzeit)) + ')'
			  minsertsql = minsertsql + ' VALUES (' + chr(39) + lower(alltrim(token(mfsatz,";",midentpos))) + chr(39) + ' , 0);'
		      strfile('Keine Objekte gefunden, starte INSERT... ' + mcrlf ,"PGcollect.log",.T.)
		      mres = PQexec(conn,minsertsql)
              strfile(str(pqresultstatus(mres),5,0) +  " | " + pqresulterrormessage(mres) + " | " + minsertsql+ mcrlf,"PGcollect.log",.T.)
		      strfile(mcrlf,"PGcollect.log",.T.)
			  ? '<I> ' + minsertsql
		   endif
   
   
   *** Fuer jedes Objekt wird dann ein Updatestatement erzeugt. **********************************************
      mfeldnr = 1
	  mupdatesql = 'UPDATE ' + alltrim(schema) + '.' + alltrim(stabelle) + ' SET '
      do while mfeldnr < mfeldanzahl + 1
	     if mfeldnr = 1
            mupdatesql = mupdatesql +  '"' + lower(alltrim(token(mkopfzeile,";",mfeldnr))) +  '"=' // ohne fhrendes Komma
		 else
            mupdatesql = mupdatesql + 	', ' + '"' + lower(alltrim(token(mkopfzeile,";",mfeldnr))) +  '"=' // fhrendes Komma bei Folgefeldern
         endif		  
		 do case
		 case left(token(mconfig,",",mfeldnr),3) = "Str" // String-Feld
		    mupdatesql = mupdatesql +  chr(39) + alltrim(token(mfsatz,";",mfeldnr)) + chr(39)
		 case left(token(mconfig,",",mfeldnr),3) = "Dat" // Datum-Feld	
		    mupdatesql = mupdatesql + 'to_date(' + chr(39) + alltrim(token(mfsatz,";",mfeldnr)) + chr(39) + ',' + chr(39) + 'YYYY/MM/DD' + chr(39) + ')'
		 case left(token(mconfig,",",mfeldnr),3) = "WKT" // Geometrie-Feld
            mupdatesql = 'Update ' + alltrim(schema) + '.' + alltrim(stabelle) + ' set "'  + alltrim(sgeom) + '"=st_geomfromtext('+chr(39) + alltrim(token(mfsatz,";",1))+ chr(39)+ ',' + alltrim(SRID) + ')'
		 
		 otherwise	
		    if len(alltrim(token(mfsatz,";",mfeldnr))) > 0 // Num-Feld mit Wert
		       mupdatesql = mupdatesql +  alltrim(token(mfsatz,";",mfeldnr))
			else
			   mupdatesql = mupdatesql +  'NULL' // Num-Feld ohne Wert
			endif
		 end case	
		 *** Ist es vielleicht das Schluesselfeld ?? Das wird fuer die WHERE-Klausel gebraucht
		 if mfeldnr = midentpos
		    if left(token(mconfig,",",mfeldnr),3) = "Str"
		       mwhereobj =  lower(alltrim(identifier)) + ' = ' + chr(39) + alltrim(token(mfsatz,";",mfeldnr)) + chr(39)
			else
			   mwhereobj =  lower(alltrim(identifier)) + ' = '  + alltrim(token(mfsatz,";",mfeldnr)) 
            endif
         endif			
        *** Hier werden die Zeitstempel gebildet *******************************************************
		mwherezeit =   lower(alltrim(szeit)) + ' < ' + alltrim(token(mfsatz,";",mzeitpos)) 
		 
         mfeldnr ++
      enddo
      mupdatesql = mupdatesql +  ' WHERE ' + mwhereobj + ' AND ' + mwherezeit + ' ;' // alles schoen zusammenbauen
	  mres = PQexec(conn,mupdatesql)
 	  mupdatenr ++
      strfile(str(pqresultstatus(mres),5,0) +  " | " + pqresulterrormessage(mres) + " | " + mupdatesql+ mcrlf,"PGcollect.log",.T.)
 	  ? '<U> ' + mupdatesql
	  mupdatesql = 'UPDATE ' + alltrim(schema) + '.' + alltrim(stabelle) + ' SET '

	endif
	  mgelesen = mgelesen + len(mfsatz)
	 win_1.restore 
	 win_1.label_13.value := alltrim(str(minsertnr,7,0))
     win_1.label_14.value := alltrim(str(mupdatenr,7,0))	 
     win_1.progress_1.value := round(((mgeradedran / msatzanzahl) * 100)  ,0)
	 win_1.Label_15.value := str(((mgeradedran / msatzanzahl) * 100) ,3,0) + ' %'
	 
enddo
*** auf der PG-Datenbank werden Objekte gelscht, die entsprechend gekennzeichnet sind ***
if len(alltrim(loeschkz)) > 0 // Eintrag zum Lschen vorhanden?
   mloeschSQL = "DELETE FROM " + alltrim(schema) + '.' + alltrim(stabelle) + " WHERE " + charrepl("#",alltrim(loeschkz),chr(39)) + ';' // die ## werden durch '' ersetzt
   mres = PQexec(conn,mloeschsql)
   strfile(str(pqresultstatus(mres),5,0) +  " | " + pqresulterrormessage(mres) + " | " + mloeschsql+ mcrlf,"PGcollect.log",.T.)
		      strfile(mcrlf,"PGcollect.log",.T.)
			  
			  ? '<L> ' + mloeschsql
endif
		  
  
fclose(mfhnr)
set print off
set print to
return
*******************************************************************************
function fpgconnect() // Verbindung zu Postgres initialisieren
set print to Postgres.log
set print on
? "Verbindung zur Datenbank"
conn = PQsetdbLogin( alltrim(SIP), "5432", NIL, NIL, alltrim(sdb), alltrim(sUser), alltrim(sPasswort) )
   ? PQdb( conn ), PQuser( conn ), PQpass( conn ), PQhost( conn ), PQport( conn ), PQtty( conn ), PQoptions( conn )
   ? PQstatus( conn ), PQerrorMessage( conn )
   IF PQstatus( conn ) != CONNECTION_OK // ob die DB verbunden wurde, sollte man immer prfen
      ? "keine Verbindung zur DB!"
        set print off
        set print to		
        fende("Keine Verbindung zur Datenbank " + alltrim(SIP) + " , " + alltrim(sdb))
    else
	? "Verbindung klappt!"
   ENDIF
?
set print off
set print to
fileappend("Postgres.log", "PGcollect.log")
filedelete("Postgres.log")
return
******************************************************************************* 
function fpgexport() // Export der PG-Daten
strfile('Rueckuebertragung der Servertabelle ' + alltrim(stabelle) + ' nach SQLITE' + mcrlf,"PGcollect.log",.T.)
set print to $PG2SQLite.bat
set print on
set console off
? "echo off"
?
?
? 'spatialite ' + alltrim(ldatei) + ' "delete from ' + alltrim(ltabelle) + ';"'
? 'spatialite ' + alltrim(ldatei) + ' "vacuum;"'
? 'ogr2ogr    -f  SQLite ' + alltrim(lower(ldatei)) + ' -nln ' + lower(alltrim(ltabelle)) + ' '
?? '-append -progress ' // nur bei -append wird die Tabelle von QGIS auch wieder erkannt
// PG-Parameter
?? 'PG:" dbname='   + alltrim(sdb)  + ' '
?? 'host='     +  alltrim(sip)  + ' '
?? 'port='     + '5432' +  ' '
?? 'user='     + alltrim(suser) + ' '
?? 'password=' +  alltrim(spasswort) +  ' '
?? 'schemas='  + alltrim(schema) + ' '
if len(alltrim(sgeom)) > 0 // Tabelle mit Geometrien
   ?? 'tables='   + lower(alltrim(stabelle)) + '(' + alltrim(sgeom) + ')" '
else // nicht-rumliche Tabelle
   ?? 'tables='   + lower(alltrim(stabelle))  + '" '
endif   
?? ' >> PGcollect.log' 
// ? 'pause'
set print off
set print to
fileappend("$pg2sqlite.bat","PGcollect.log")
EXECUTE file "$PG2SQLITE.bat" wait
return
***************************************************************************************
function fpruef
parameters mpruefdatei
mprueffhnr = fopen(mpruefdatei,16)
merror = ferror()
fclose(mprueffhnr)
if merror <> 0
      fende("Fehler " + str(merror,2,0) + " ,die Datei " + alltrim(mpruefdatei) + " ist nicht geschlossen oder nicht vorhanden.")
   return .F.
else
   fclose(mprueffhnr)
endif
return .T.

***********************************************************************************
function fende() // im Fehlerfall kontrolliertes Programmende
parameters mgrund
msginfo(mgrund,"fehlerhafter Programmabbruch")
strfile(mgrund,"PGcollect-ERROR.TXT")
quit
return
